
--///////////////////////////////START CONTROL SCRIPT

--DOESN'T WORK!
--dofile("Dummy.rte/Crafts/Rocklet.lua")

function Update(self)
--Just here to see notifications of this running.
--print("running the movement script!")

--Create the necessary variables.
if self.timer == nil then
	self.timer = Timer();
end

--Start our loop, every 10-20ms.
local randomTimer = math.random(10,20);
if self.timer:IsPastSimMS(randomTimer) then
	local p = Vector();

	--Core of the Movement script starts here.
	--Important bit here- adjust the altitude value until it's stable and not too floaty.  
	--This specific altitude should be slightly lower than the AHuman's hip center to the ground.
	local altCheck = 12
	local heightCheck = 50
	local sideCheck = 25
	local upPush = 0.5
	local downPush = 1.5
	local downCheck = false
	local upCheck = false

	local centerAlt = SceneMan:CastObstacleRay(self.Pos, Vector(0,altCheck), p, p, self.ID, 0, 0, 0);
	local frontAlt = SceneMan:CastObstacleRay(Vector(self.Pos.X-4,self.Pos.Y), Vector(0,altCheck), p, p, self.ID, 0, 0, 0);
	local backAlt = SceneMan:CastObstacleRay(Vector(self.Pos.X+4,self.Pos.Y), Vector(0,altCheck), p, p, self.ID, 0, 0, 0);
	
	--Safety code, because we get -1 if no obstacles
	if centerAlt < 0 then
		centerAlt = 1000
	end
	if frontAlt < 0 then
		frontAlt = 1000
	end
	if backAlt < 0 then
		backAlt = 1000
	end

	--Now that we know the heights to obstacles, it's time to perform some logic.
	--May need to alter the velPushfor best performance depending on mass.
	--Please note that this allows for ducking and prone and even movement while body is lowered; let go of the control...
	--...and the character "stands" back up again.
	if (centerAlt < altCheck or frontAlt < altCheck or backAlt < altCheck) and not self:GetController():IsState(Controller.MOVE_DOWN) then
		downCheck = true
	elseif self:GetController():IsState(Controller.MOVE_DOWN) then
		self.Vel.Y = self.Vel.Y + 0.1
	end

	--Do a raytest vs. hitting top of the Actor on things.  If buried, push down, hard.
	local ray = SceneMan:CastObstacleRay(self.Pos, Vector(4,-heightCheck), p, p, self.ID, 0, 0, 0);
	if ray < heightCheck and ray ~= -1 then
		upCheck = true
	end
	ray = SceneMan:CastObstacleRay(self.Pos, Vector(-4,-heightCheck), p, p, self.ID, 0, 0, 0);
	if ray < heightCheck and ray ~= -1 then
		upCheck = true
	end
	
	--If we're supposed to push DOWN or UP, do one or the other, but if both conditions... 
	--...are true or false, do NOTHING.  Prevents odd behaviors underground
	if downCheck == true and upCheck == false then
		self.Vel.Y = self.Vel.Y - upPush
	end	
	if downCheck == false and upCheck == true then
		self.Vel.Y = self.Vel.Y + downPush
	end

	--Do raytests to the right and left to make sure we're not running through walls.
	--This isn't exactly super-reliable, but it's better'n nothin'.
	local rightLeft = 0
	ray = SceneMan:CastObstacleRay(self.Pos, Vector(sideCheck,0), p, p, self.ID, 0, 0, 0);
	if ray < sideCheck and ray ~= -1 then
		rightLeft = rightLeft -1
	end
	ray = SceneMan:CastObstacleRay(self.Pos, Vector(-sideCheck,0), p, p, self.ID, 0, 0, 0);
	if ray < sideCheck and ray ~= -1 then
		rightLeft = rightLeft + 1
	end
	--If we want to push right OR left, but NOT push right AND left, then push right or left.
	--Sorry for the logic joke.
	if rightLeft == -1 then
		self.Vel.X = self.Vel.X - 1.0
	end
	if rightLeft == 1 then
		self.Vel.X = self.Vel.X + 1.0
	end	

	--Brute-force change in velocity over time. 
	--If accel is set really high, bad things will happen ;-)
	local speed_max = 6.0
	local accel = 0.5
	if self:GetController():IsState(Controller.MOVE_LEFT) and rightLeft == 0 then
		self.Vel.X = math.max(self.Vel.X - accel,-speed_max)
	end
	if self:GetController():IsState(Controller.MOVE_RIGHT) and rightLeft == 0 then
		self.Vel.X = math.min(self.Vel.X + accel,speed_max)
	end	
	

	--Brute-force adjustments of RotAngles, to prevent funky behaviors.		
	if self.RotAngle > 0.1 then
		self.RotAngle = 0.1
	end	
	if self.RotAngle < - 0.1 then
		self.RotAngle = -0.1
	end		


	if self.Controller == nil then
		self.Controller = self:GetController()
	end	
	--Regulate how fast we travel downwards.
	if self.Vel.Y > 10.0 and not self:GetController():IsState(Controller.MOVE_DOWN) then
		self.Controller:SetState(Controller.MOVE_UP, true)
	end

	--Brute-force removal of "falling through the earth"; troops hit "bedrock".
	if self.Pos.Y > SceneMan.SceneHeight - 40 then 
		self.Pos.Y = SceneMan.SceneHeight - 42
		self.Vel.Y = -1.0
	end

	--Reset our 10ms timer
	self.timer:Reset();
--End our loop
end
--End the Update() cycle
end
--///////////////////////////////END CONTROL SCRIPT

---------------------------------------------------
-- PID controller class
-- http://en.wikipedia.org/wiki/PID_controller
---------------------------------------------------

-- Create a new regulator by specifying the parameters in a table like this:
-- self.myPID = RegulatorPID:New{p=0.1, i=0.1, d=0.1, last_input=0, filter_leak=0.5, integral_max=100}
-- self.myPD = RegulatorPID:New{p=0.2, d=0.5, filter_leak=0.7, integral_max=50}
-- All parameters are optional

RegulatorPID = {}
RegulatorPID.mt = {__index = RegulatorPID}
function RegulatorPID:New(Inputs)
	return setmetatable(
		{
			p = Inputs.p or 0,
			i = Inputs.i or 0,
			d = Inputs.d or 0,
			last_input = Inputs.last_input or 0,
			filter_leak = Inputs.filter_leak or 1,
			filtered_input = Inputs.last_input or 0,
			integral = 0,
			integral_max = Inputs.integral_max or math.huge / 2,
		},
		RegulatorPID.mt)
end

function RegulatorPID:Update(raw_input, target)
	self.filtered_input = self.filtered_input * (1-self.filter_leak) + raw_input * self.filter_leak
	local err = self.filtered_input - target
	local change = self.filtered_input - self.last_input
	self.last_input = self.filtered_input
	self.integral = math.min(math.max(self.integral + err, -self.integral_max), self.integral_max)
	return self.p*err + self.i*self.integral + self.d*change
end

function Create(self)
	---------------- AI variables start ----------------
	self.StableTimer = Timer()
	self.DoorTimer = Timer()
	
	self.ObstacleTimer = Timer()
	self.ObstacleTimer:SetSimTimeLimitMS(100)
	
	self.PlayerInterferedTimer = Timer()
	self.PlayerInterferedTimer:SetSimTimeLimitMS(500)
	
	self.DeliveryState = ACraft.FALL
	self.LastAIMode = Actor.AIMODE_NONE
	self.Controller = self:GetController()
	self.groundDist = self.Radius / 1.35
	
	self.LZpos = SceneMan:MovePointToGround(self.Pos, self.groundDist, 5)
	self.velIntegrator = 0
	
	if self.AIMode == Actor.AIMODE_DELIVER and self:IsInventoryEmpty() then
		self.AIMode = Actor.AIMODE_STAY	-- stop the craft from returning to orbit immediately
	end
	
	self.MoveLZ = function()
		local FuturePos = self.Pos + self.Vel*7
		
		-- Make sure FuturePos is inside the scene
		if FuturePos.X > SceneMan.SceneWidth then
			if SceneMan.SceneWrapsX then
				FuturePos.X = FuturePos.X - SceneMan.SceneWidth
			else
				FuturePos.X = SceneMan.SceneWidth - self.Radius
			end
		elseif FuturePos.X < 0 then
			if SceneMan.SceneWrapsX then
				FuturePos.X = FuturePos.X + SceneMan.SceneWidth
			else
				FuturePos.X = self.Radius
			end
		end
		
		if self.DeliveryState == ACraft.LAUNCH then
			self.LZpos.X = FuturePos.X
		else
			local TestPos = Vector(FuturePos.X, math.min(FuturePos.Y, self.Pos.Y))
			self.LZpos = SceneMan:MovePointToGround(TestPos, self.groundDist, 5)
		end
	end
	
	-- The controllers
	self.AngPID = RegulatorPID:New{p=3, i=0.005, d=1, last_input=self.RotAngle, filter_leak=0.6}
	self.XposPID = RegulatorPID:New{p=0.2, d=0.5, filter_leak=0.6, integral_max=100}
	self.YposPID = RegulatorPID:New{p=0.012, i=0.00005, d=3.8, last_input=self.LZpos.Y, filter_leak=0.5, integral_max=20}
	
	---------------- AI variables end ----------------
end

function UpdateAI(self)
	if self.PlayerInterferedTimer:IsPastSimTimeLimit() then
		self.MoveLZ()
	end
	
	self.PlayerInterferedTimer:Reset()
	
	if self.AIMode ~= self.LastAIMode then
		self.LastAIMode = self.AIMode

		if self.AIMode == Actor.AIMODE_RETURN then
			self.DeliveryState = ACraft.LAUNCH
			self.LZpos.Y = -10000	-- Go to orbit
			self.MoveLZ()
		else
			self.DeliveryState = ACraft.FALL
			self.MoveLZ()
		end
	end
	
	-- Reset the timer if not in a stable and upright state
	self.velIntegrator = self.velIntegrator * 0.8 + self.Vel.Magnitude * 0.2
	if self.velIntegrator > 3 or math.abs(self.AngularVel) > 1.5 then
		self.StableTimer:Reset()
	else
		self.LZpos.X = self.Pos.X
	end
	
	-- Delivery Sequence logic
	if self.DeliveryState == ACraft.FALL then		
		self.checkLZ = not self.checkLZ	-- Only check every second frame
		if self.checkLZ then
			-- Move Landing Zone closer to the rocket if it is about to collide with something
			if (self.LZpos.Y-self.Pos.Y) > self.Radius then
				local Speed = (self.Vel + Vector(0,4))*15
				if SceneMan:CastObstacleRay(self.Pos, Speed, Vector(), Vector(), self.ID, self.IgnoresWhichTeam, 0, 10) > -1 then
					self.MoveLZ()
				end
			end
		else
			-- Check for something in the way of our descent, and move to the side to avoid it
			if self.ObstacleTimer:IsPastSimTimeLimit() then
				self.ObstacleTimer:Reset()
				
				local Trace = Vector(self.Vel.X+RangeRand(-1,1), math.max(self.Vel.Y,2)) * 40
				local obstID = SceneMan:CastMORay(self.Pos, Trace, self.ID, self.IgnoresWhichTeam, 0, false, 5)
				if obstID < 255 then
					local MO = MovableMan:GetMOFromID(MovableMan:GetRootMOID(obstID))
					if MO.ClassName == "ACDropShip" or MO.ClassName == "ACRocket" then
						self.LZpos:SetXY(MO.Pos.X+MO.Radius*3, math.max(self.Pos.Y-200,0))
						self.ObstacleTimer:SetSimTimeLimitMS(750)
						self.obstacle = true
					elseif MovableMan:IsActor(MO) and MO.Team == self.Team then
						local newLZx = MO.Pos.X+MO.Diameter+self.Diameter
						
						-- Make sure newLZx is inside the scene
						if newLZx > SceneMan.SceneWidth then
							if SceneMan.SceneWrapsX then
								newLZx = newLZx - SceneMan.SceneWidth
							else
								newLZx = MO.Pos.X - (MO.Diameter + self.Diameter)
							end
						end
						
						self.LZpos:SetXY(newLZx, math.max(MO.Pos.Y-200,0))
					end
				elseif self.obstacle then
					self.obstacle = false
					self.MoveLZ()
					self.ObstacleTimer:SetSimTimeLimitMS(100)
				end
			end
		end
		
		if self.AIMode == Actor.AIMODE_DELIVER and self:IsInventoryEmpty() then
			self.DeliveryState = ACraft.LAUNCH	-- Don't descend if we have nothing to deliver
			self.LZpos.Y = -10000	-- Go to orbit
		else
			if self.StableTimer:IsPastSimMS(500) then	-- Move LZ if stable
				self.LZpos = SceneMan:MovePointToGround(Vector(self.Pos.X, self.Pos.Y), self.groundDist, 6)
			end
			
			if self.AIMode ~= Actor.AIMODE_STAY then
				local dist = SceneMan:ShortestDistance(self.Pos, self.LZpos, false).Magnitude
				if dist < 20 then	-- If we passed the check, start unloading
					self.DeliveryState = ACraft.UNLOAD
				end
			end
		end
	elseif self.DeliveryState == ACraft.UNLOAD then
		if self:IsInventoryEmpty() then	-- Return to orbit if empty
			if self.HatchState == ACraft.OPEN then
				self:CloseHatch()
			end
			
			if self.DoorTimer:IsPastSimMS(2000) then	-- Pause before returning to orbit
				self.DeliveryState = ACraft.LAUNCH
				self.LZpos.Y = -10000	-- Go to orbit
			end
		elseif self.StableTimer:IsPastSimMS(400) and self.HatchState == ACraft.CLOSED then
			self:OpenHatch()
			self.DoorTimer:Reset()
		end
	elseif self.DeliveryState == ACraft.LAUNCH then
		-- Check for something in the way of our ascent, and move to the side to avoid it
		if self.ObstacleTimer:IsPastSimTimeLimit() then
			self.ObstacleTimer:Reset()
			
			local Trace = Vector(self.Vel.X+RangeRand(-1,1), math.min(self.Vel.Y,-1)) * 50
			local obstID = SceneMan:CastMORay(self.Pos, Trace, self.ID, self.IgnoresWhichTeam, 0, false, 5)
			if obstID < 255 then
				local MO = MovableMan:GetMOFromID(MovableMan:GetRootMOID(obstID))
				if MO.ClassName == "ACDropShip" or MO.ClassName == "ACRocket" then
					self.LZpos:SetXY(MO.Pos.X-(MO.Diameter+self.Diameter), self.Pos.Y+self.Vel.Y)
					self.ObstacleTimer:SetSimTimeLimitMS(750)
					self.obstacle = true
				end
			elseif self.obstacle then
				self.obstacle = false
				self.LZpos.Y = -10000	-- Go to orbit
				self.MoveLZ()
				self.ObstacleTimer:SetSimTimeLimitMS(100)
			else
				self.MoveLZ()	-- move the exit point closer towards us
			end
		end
	end
	
	-- Control up/down movement
	if self.DeliveryState ~= ACraft.UNLOAD then
		local change = self.YposPID:Update(-(self.LZpos.Y-self.Pos.Y), 0)
		if math.abs(self.RotAngle) < 0.8 then
			if change > 6 then
				self.burstDown = math.max(18-change, 8)
			elseif change < -15 then
				self.Controller:SetState(Controller.MOVE_DOWN, true)
			end
		elseif self.RotAngle > 2.14 and self.RotAngle < 4.14 then	-- Upside down
			self.Controller:SetState(Controller.MOVE_DOWN, true)
		end
	end
	
	-- Control right/left movement (the rocket will move sideways if rotated to the side)
	local dist = SceneMan:ShortestDistance(self.Pos+self.Vel*20, self.LZpos, false).X
	change = self.XposPID:Update(dist, 0)
	local targetAng = 0
	if self.Vel.Y > 0 then
		if change < -4 then
			targetAng = -math.max(change/40, -0.5)
		elseif change > 4 then
			targetAng = -math.min(change/40, 0.5)
		end
	else
		if change > 4 then
			targetAng = -math.max(change/40, -0.5)
		elseif change < -4 then
			targetAng = -math.min(change/40, 0.5)
		end
	end
	
	-- Control angle
	change = self.AngPID:Update(self.RotAngle+self.AngularVel, targetAng)
	if change > 1 and not self.burstRight then
		self.burstRight = math.max(6-change, 2) -- Wait n frames until next burst (lower -> better control)
	elseif change < -1 and not self.burstLeft then
		self.burstLeft = math.max(6+change, 2)
	end
	
	-- Trigger bursts
	if self.burstRight then
		self.burstRight = self.burstRight - 1
		if self.burstRight < 0 then			
			self.Controller:SetState(Controller.MOVE_RIGHT, true)
			if self.burstRight < -8 then	-- Fire for -n frames (higher -> better control)
				self.burstRight = nil	-- Allow a new burst
			end
		end
	end
	
	if self.burstLeft then
		self.burstLeft = self.burstLeft - 1
		if self.burstLeft < 0 then
			self.Controller:SetState(Controller.MOVE_LEFT, true)
			if self.burstLeft < -8 then
				self.burstLeft = nil
			end
		end
	end
	
	if self.burstDown then
		if self.burstDown > 0 then
			self.Controller:SetState(Controller.MOVE_UP, true)
			self.burstDown = self.burstDown - 1
		else
			self.burstDown = nil
		end
	end
end
